///programare dinamica + deque; complexitate O(N)
#include <deque>
#include <vector>
#include <cstdint>
#include <fstream>
using namespace std;

int main() {
    ifstream        f("pqstr.in");
    ofstream        g("pqstr.out");
    int             N, P, Q; f >> N >> P >> Q;
    vector<int>     A(N);
    vector<int64_t> plus(N), minus(N);
    deque<int>      X, Y;
    int64_t         ans = 0;

    for (int i = 0; i < N; i++) f >> A[i];

    for (int i = 0; i < N; i++) {
        // update the sliding window for the plus[i-Q .. i-P] candidates
        if (!X.empty() && X.front() < i - Q) X.pop_front();
        if (i >= P) {
            while (!X.empty() && plus[X.back()] <= plus[i - P]) X.pop_back();
            X.push_back(i - P);
        }

        // update the sliding window for the minus[i-Q .. i-P] candidates
        if (!Y.empty() && Y.front() < i - Q) Y.pop_front();
        if (i >= P) {
            while (!Y.empty() && minus[Y.back()] <= minus[i - P]) Y.pop_back();
            Y.push_back(i - P);
        }

        // combine the best results of the two type of candidates
        int64_t best = 0;
        if (!X.empty()) best = max(best, plus[X.front()]  - A[i]);
        if (!Y.empty()) best = max(best, minus[Y.front()] + A[i]);
        ans         = max(ans, best);
        plus[i]     = best + A[i];
        minus[i]    = best - A[i];
    }
    g << ans;

    return 0;
}
